--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 7.1.01i
--  \   \         Application : sch2vhdl
--  /   /         Filename : LA_top.vhf
-- /___/   /\     Timestamp : 04/05/2005 16:41:07
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: D:/Programme/Xilinx/bin/nt/sch2vhdl.exe -intstyle ise -family spartan3 -flat -suppress -w LA_top.sch LA_top.vhf
--Design Name: LA_top
--Device: spartan3
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesis and simulted, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
-- synopsys translate_off
library UNISIM;
use UNISIM.Vcomponents.ALL;
-- synopsys translate_on

entity LA_top is
   port ( clk     : in    std_logic; 
          LA_DATA : in    std_logic_vector (7 downto 0); 
          reset   : in    std_logic; 
          uart_rx : in    std_logic; 
          uart_tx : out   std_logic);
end LA_top;

architecture BEHAVIORAL of LA_top is
   signal XLXN_31  : std_logic_vector (7 downto 0);
   signal XLXN_32  : std_logic_vector (7 downto 0);
   signal XLXN_33  : std_logic_vector (7 downto 0);
   signal XLXN_34  : std_logic_vector (7 downto 0);
   signal XLXN_35  : std_logic_vector (7 downto 0);
   signal XLXN_36  : std_logic_vector (7 downto 0);
   signal XLXN_48  : std_logic_vector (7 downto 0);
   signal XLXN_52  : std_logic_vector (7 downto 0);
   signal XLXN_64  : std_logic;
   signal XLXN_65  : std_logic_vector (7 downto 0);
   signal XLXN_66  : std_logic;
   signal XLXN_67  : std_logic;
   signal XLXN_69  : std_logic_vector (7 downto 0);
   signal XLXN_86  : std_logic;
   signal XLXN_91  : std_logic_vector (7 downto 0);
   signal XLXN_92  : std_logic_vector (2 downto 0);
   signal XLXN_93  : std_logic;
   signal XLXN_96  : std_logic;
   signal XLXN_99  : std_logic;
   signal XLXN_100 : std_logic;
   signal XLXN_101 : std_logic;
   signal XLXN_102 : std_logic;
   component uart_top
      port ( clk             : in    std_logic; 
             reset           : in    std_logic; 
             rx              : in    std_logic; 
             send_character  : in    std_logic; 
             data_in         : in    std_logic_vector (7 downto 0); 
             rx_data_present : out   std_logic; 
             tx              : out   std_logic; 
             tx_active       : out   std_logic; 
             TX_complete     : out   std_logic; 
             data_out        : out   std_logic_vector (7 downto 0));
   end component;
   
   component regfile
      port ( clk           : in    std_logic; 
             reset         : in    std_logic; 
             trigger_found : in    std_logic; 
             wr            : in    std_logic; 
             datain        : in    std_logic_vector (7 downto 0); 
             addr          : in    std_logic_vector (2 downto 0); 
             arm           : out   std_logic; 
             fe_mask       : out   std_logic_vector (7 downto 0); 
             re_mask       : out   std_logic_vector (7 downto 0); 
             datamask      : out   std_logic_vector (7 downto 0); 
             fe_data       : out   std_logic_vector (7 downto 0); 
             re_data       : out   std_logic_vector (7 downto 0); 
             data          : out   std_logic_vector (7 downto 0));
   end component;
   
   component control
      port ( clk            : in    std_logic; 
             reset          : in    std_logic; 
             TX_complete    : in    std_logic; 
             data_present   : in    std_logic; 
             trigger_found  : in    std_logic; 
             aqui_finished  : in    std_logic; 
             uart_data_in   : in    std_logic_vector (7 downto 0); 
             ram_data_in    : in    std_logic_vector (7 downto 0); 
             send_character : out   std_logic; 
             write_regfile  : out   std_logic; 
             reset_ram      : out   std_logic; 
             ram_data_out   : out   std_logic; 
             uart_data_out  : out   std_logic_vector (7 downto 0); 
             write_addr     : out   std_logic_vector (2 downto 0); 
             write_data     : out   std_logic_vector (7 downto 0); 
             read_finished  : in    std_logic);
   end component;
   
   component trigger
      port ( clk      : in    std_logic; 
             arm      : in    std_logic; 
             datamask : in    std_logic_vector (7 downto 0); 
             re_mask  : in    std_logic_vector (7 downto 0); 
             fe_mask  : in    std_logic_vector (7 downto 0); 
             compdata : in    std_logic_vector (7 downto 0); 
             comp_re  : in    std_logic_vector (7 downto 0); 
             comp_fe  : in    std_logic_vector (7 downto 0); 
             d        : in    std_logic_vector (7 downto 0); 
             data_en  : out   std_logic; 
             trigout  : out   std_logic; 
             data_out : out   std_logic_vector (7 downto 0));
   end component;
   
   component la_blockram
      port ( clk             : in    std_logic; 
             reset           : in    std_logic; 
             trigger         : in    std_logic; 
             read_en         : in    std_logic; 
             din             : in    std_logic_vector (7 downto 0); 
             read_finish     : out   std_logic; 
             aqui_finished   : out   std_logic; 
             trigger_address : out   std_logic_vector (10 downto 0); 
             dout            : out   std_logic_vector (7 downto 0); 
             reset_cnt       : in    std_logic);
   end component;
   
begin
   XLXI_1 : uart_top
      port map (clk=>clk,
                data_in(7 downto 0)=>XLXN_65(7 downto 0),
                reset=>reset,
                rx=>uart_rx,
                send_character=>XLXN_64,
                data_out(7 downto 0)=>XLXN_69(7 downto 0),
                rx_data_present=>XLXN_67,
                tx=>uart_tx,
                tx_active=>open,
                TX_complete=>XLXN_66);
   
   XLXI_2 : regfile
      port map (addr(2 downto 0)=>XLXN_92(2 downto 0),
                clk=>clk,
                datain(7 downto 0)=>XLXN_91(7 downto 0),
                reset=>reset,
                trigger_found=>XLXN_96,
                wr=>XLXN_93,
                arm=>XLXN_86,
                data(7 downto 0)=>XLXN_31(7 downto 0),
                datamask(7 downto 0)=>XLXN_34(7 downto 0),
                fe_data(7 downto 0)=>XLXN_33(7 downto 0),
                fe_mask(7 downto 0)=>XLXN_36(7 downto 0),
                re_data(7 downto 0)=>XLXN_32(7 downto 0),
                re_mask(7 downto 0)=>XLXN_35(7 downto 0));
   
   XLXI_3 : control
      port map (aqui_finished=>XLXN_100,
                clk=>clk,
                data_present=>XLXN_67,
                ram_data_in(7 downto 0)=>XLXN_52(7 downto 0),
                read_finished=>XLXN_101,
                reset=>reset,
                trigger_found=>XLXN_96,
                TX_complete=>XLXN_66,
                uart_data_in(7 downto 0)=>XLXN_69(7 downto 0),
                ram_data_out=>XLXN_99,
                reset_ram=>XLXN_102,
                send_character=>XLXN_64,
                uart_data_out(7 downto 0)=>XLXN_65(7 downto 0),
                write_addr(2 downto 0)=>XLXN_92(2 downto 0),
                write_data(7 downto 0)=>XLXN_91(7 downto 0),
                write_regfile=>XLXN_93);
   
   XLXI_4 : trigger
      port map (arm=>XLXN_86,
                clk=>clk,
                compdata(7 downto 0)=>XLXN_31(7 downto 0),
                comp_fe(7 downto 0)=>XLXN_33(7 downto 0),
                comp_re(7 downto 0)=>XLXN_32(7 downto 0),
                d(7 downto 0)=>LA_DATA(7 downto 0),
                datamask(7 downto 0)=>XLXN_34(7 downto 0),
                fe_mask(7 downto 0)=>XLXN_36(7 downto 0),
                re_mask(7 downto 0)=>XLXN_35(7 downto 0),
                data_en=>open,
                data_out(7 downto 0)=>XLXN_48(7 downto 0),
                trigout=>XLXN_96);
   
   XLXI_5 : la_blockram
      port map (clk=>clk,
                din(7 downto 0)=>XLXN_48(7 downto 0),
                read_en=>XLXN_99,
                reset=>reset,
                reset_cnt=>XLXN_102,
                trigger=>XLXN_96,
                aqui_finished=>XLXN_100,
                dout(7 downto 0)=>XLXN_52(7 downto 0),
                read_finish=>XLXN_101,
                trigger_address=>open);
   
end BEHAVIORAL;


