-- Vhdl test bench created from schematic LA_top.sch - Thu Mar 31 19:42:46 2005
--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Xilinx recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "Source->Add"
-- menu in Project Navigator to import the testbench. Then
-- edit the user defined section below, adding code to generate the 
-- stimulus for your design.
--
LIBRARY ieee;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;
ENTITY LA_top_LA_top_sch_tb IS
END LA_top_LA_top_sch_tb;
ARCHITECTURE behavioral OF LA_top_LA_top_sch_tb IS 

   COMPONENT LA_top
   PORT( uart_rx	:	IN	STD_LOGIC; 
          LA_DATA	:	IN	STD_LOGIC_VECTOR (7 DOWNTO 0); 
          reset	:	IN	STD_LOGIC; 
          clk	:	IN	STD_LOGIC; 
          uart_tx	:	OUT	STD_LOGIC);
   END COMPONENT;

   SIGNAL uart_rx	:	STD_LOGIC;
   SIGNAL LA_DATA	:	STD_LOGIC_VECTOR (7 DOWNTO 0);
   SIGNAL reset	:	STD_LOGIC;
   SIGNAL clk	:	STD_LOGIC;
   SIGNAL uart_tx	:	STD_LOGIC;

	signal cnt : std_logic_vector(7 downto 0);
	signal SEND_DATA:std_logic_vector(7 downto 0);

		-- proceduren
procedure send_uart(	signal data	: in std_logic_vector(7 downto 0);
        		    			signal rx : out std_logic
							) is
begin
-- 115200 Baud
rx<='1'; wait for 1 ns;
-- startzeichen 1
rx<='0'; wait for 8.681 us;
-- daten
-- LSB
rx<=data(0); wait for 8.681 us;
rx<=data(1); wait for 8.681 us;
rx<=data(2); wait for 8.681 us;
rx<=data(3); wait for 8.681 us;

rx<=data(4); wait for 8.681 us;
rx<=data(5); wait for 8.681 us;
rx<=data(6); wait for 8.681 us;
rx<=data(7); wait for 8.681 us;	  -- MSB
-- stopp
rx<='1'; wait for 200 us;	
		
end send_uart;
BEGIN

   UUT: LA_top PORT MAP(
		uart_rx => uart_rx, 
		LA_DATA => LA_DATA, 
		reset => reset, 
		clk => clk, 
		uart_tx => uart_tx
   );

-- *** Test Bench - User Defined Section ***
	tb_clk : PROCESS
	BEGIN
		clk<='0'; wait for 10 ns;
		clk<='1'; wait for 10 ns;
	END PROCESS;

	tb_reset : PROCESS
	BEGIN
		reset<='1'; wait for 5 ns;
		reset<='0'; wait for 10 ns;
		wait; 
	END PROCESS;

	tb_data_rx : PROCESS
	BEGIN
		uart_rx<='1';
		wait for 100 us;

		-- 2. Reg status
		SEND_DATA<=x"01";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		SEND_DATA<=x"00";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		-- 3. Reg re_mask
		SEND_DATA<=x"02";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		SEND_DATA<=x"00";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		-- 4. Reg fe_mask
		SEND_DATA<=x"03";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		SEND_DATA<=x"00";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		-- 5. Reg datamask
		SEND_DATA<=x"04";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		SEND_DATA<=x"80";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		-- 6. Reg re_data
		SEND_DATA<=x"05";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		SEND_DATA<=x"00";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		-- 7. Reg fe_data
		SEND_DATA<=x"06";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		SEND_DATA<=x"00";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		-- 8. Reg data
		SEND_DATA<=x"07";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		SEND_DATA<=x"80";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		-- 1. Reg control
		-- MSB = ARM
		SEND_DATA<=x"00";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		SEND_DATA<=x"80";
		send_uart(	data=>SEND_DATA,
        		    	rx=>uart_rx);
		wait; 
	END PROCESS;

	tb_la_data: process

	begin
		cnt<=x"00";
		la_data<=x"00";
		wait for 5 ms;
		loop
			cnt<=cnt+1;
			la_data<=cnt;
			wait for 20 ns;
		end loop;

		
		wait;
	end process;


-- *** End Test Bench - User Defined Section ***

END;
