--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 7.1i
--  \   \         Application : sch2vhdl
--  /   /         Filename : top.vhf
-- /___/   /\     Timestamp : 03/26/2005 23:32:58
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: D:/Programme/Xilinx/bin/nt/sch2vhdl.exe -intstyle ise -family spartan3 -flat -suppress -w top.sch top.vhf
--Design Name: top
--Device: spartan3
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesis and simulted, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
-- synopsys translate_off
library UNISIM;
use UNISIM.Vcomponents.ALL;
-- synopsys translate_on

entity uart_top is
   port ( clk                 : in    std_logic; 
          reset               : in    std_logic; 
          rx                  : in    std_logic; 
          data_out            : out   std_logic_vector (7 downto 0); 
			 data_in					: in 	  std_logic_vector (7 downto 0);
		    rx_data_present     : out	  std_logic;
			 send_character			: in 	  std_logic;
          tx                  : out   std_logic;
			 tx_active				: out  std_logic;
			 TX_complete			: out  std_logic 
			 );
end uart_top;

architecture BEHAVIORAL of uart_top is
	signal SIG_baud_en_16x: std_logic;

   component uart_rx
      port ( serial_in           : in    std_logic; 
             en_16_x_baud        : in    std_logic; 
             clk                 : in    std_logic; 
             buffer_data_present : out   std_logic; 
             data_out            : out   std_logic_vector (7 downto 0)
				 );
   end component;
   
   component uart_timer
    Port ( clk50 : in std_logic;
           reset : in std_logic;
           baud_en_16x : out std_logic
			  );
   end component;
   
   component uart_tx
      port (   data_in : in std_logic_vector(7 downto 0);
           send_character : in std_logic;
             en_16_x_baud : in std_logic;
               serial_out : out std_logic;
              Tx_complete : out std_logic;
				  Tx_active	  : out std_logic;
                      clk : in std_logic
				);
   end component;
   
begin
   receiver : uart_rx
      port map (clk=>clk,
                en_16_x_baud=>SIG_baud_en_16x,
                serial_in=>rx,
                buffer_data_present=>rx_data_present,
                data_out(7 downto 0)=>data_out(7 downto 0));
   
   timer : uart_timer
      port map (clk50=>clk,
                reset=>reset,
                baud_en_16x=>SIG_baud_en_16x
					 );
   
   transmitter : uart_tx
      port map (
					 data_in=>data_in,
           		 send_character=>send_character,
                en_16_x_baud=>sig_baud_en_16x,
                serial_out=>tx,
                Tx_complete=>tx_complete,
				    Tx_active=>tx_active,
                clk=>clk
					  );
   
end BEHAVIORAL;


