library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity uart_timer is
    Port ( clk50 : in std_logic;
           reset : in std_logic;
           baud_en_16x : out std_logic);
end uart_timer;

architecture Behavioral of uart_timer is

signal baud_cnt: integer range 0 to  26 :=0;

begin
-- timing for 115200 Baud
baud_timer_cnt: process(reset,clk50)
begin
	if reset='1' then
		baud_en_16x<='0';
		baud_cnt<=0;
	elsif rising_edge(clk50) then
		if baud_cnt=26 then
			baud_cnt<=0;
			baud_en_16x<='1';
		else
			baud_cnt<=baud_cnt+1;
			baud_en_16x<='0';
		end if;
	end if;
end process;

end Behavioral;
